/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package drivers;

/**
 *
 * @author asistentes-ti2 (Angel Mena Coudin)
 */

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import java.util.Date;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;

@ManagedBean(name = "Registro")
@RequestScoped
public class RegisterDriver {
  // Attributes
  private String name = null;
  private String email = null;
  private String password = null;
  private String gender = "";
  private Date birthday = null;
  
  // SQL requests
  String sql_user_request_insert = "INSERT INTO `users`(`nombre`, `genero`,"
              + "`cumpleaños`, `correo`, `contraseña`) VALUES (?,?,?,?,?)";
  
  // Get and Set
  // Return the name of the user
  public String getName() {
    return this.name;
  }

  // set the name of the user
  public void setName(String name) {
    this.name = name;
  }
  
  // Return the email of the user
  public String getEmail() {
    return this.email;
  }

  // set the email of the user
  public void setEmail(String email) {
    this.email = email;
  }
  
  // Return the password of the user
  public String getPassword() {
    return this.password;
  }

  // set the password of the user
  public void setPassword(String password) {
    this.password = password;
  }
  
  // Return the gender of the user
  public String getGender() {
    return this.gender;
  }

  // set the gender of the user
  public void setGender(String gender) {
    this.gender = gender;
  }
  
  // Return the birthday of the user
  public Date getBirthday() {
    return this.birthday;
  }

  // set the birthday of the user
  public void setBirthday(Date birthday) {
    this.birthday = birthday;
  }
  
  // Registrar usuario
  public String registrar() {
    if (this.name != null && this.email != null && this.password != null
        && this.gender != null && this.birthday != null) {
      // Conectar a la base de datos
      try {
        // Contexto JNDI
        Context JNDI = new InitialContext();
        
        // Buscar el DS(base de datos) por el JNDI
        DataSource dataSource = null;
        try {
          dataSource = (DataSource) JNDI.lookup("jdbc/MySQLDBAngel");
        } catch (NamingException e) {
          Logger.getLogger(RegisterDriver.class.getName()).log(Level.SEVERE,
              "Error al obtener el DataSource", e);
          return "register.xhtml";  // Si no se puede obtener el DataSource
        }
        
        // Obtener la conexión al DS
        try(Connection conn = dataSource.getConnection()) {
          // Inserción SQL
          String sql_request = this.sql_user_request_insert;
          
          // Modificar consulta
          try (PreparedStatement full_request =
              conn.prepareStatement(sql_request)) {
            full_request.setString(1, this.name);
            full_request.setString(2, this.gender);
            full_request.setDate(3, new java.sql.Date(this.birthday.getTime()));
            full_request.setString(4, this.email);
            full_request.setString(5, this.password);
            
            full_request.executeUpdate();
          } catch (SQLException ex) {
            Logger.getLogger(RegisterDriver.class.getName()).log(Level.SEVERE,
                "Error en la consulta SQL o en los parámetros", ex);
            return "register.xhtml";  // Si hay error al insertar
          }
        }
        return "login.xhtml";
      } catch (Exception ex) {
        Logger.getLogger(RegisterDriver.class.getName()).log(Level.SEVERE,
            "Error de conexión o de configuración", ex);
        return "register.xhtml";  // Página de registro si hay un error
      }
    } else {
      return "register.xhtml";  // Página de registro si hay un atributo vacío
    }
  }
}
